﻿using Benday.CodedUi2012.WebSamples.Mvc4WebUi.Models;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using System.Text;

namespace Benday.CodedUi2012.WebSamples.Mvc4WebUi.Controllers
{
    public class ListControlsController : Controller
    {
        public ActionResult Index()
        {

            var viewInstance = new Benday.CodedUi2012.WebSamples.Mvc4WebUi.Models.ListControlsModel();

            viewInstance.Message = "not set";

            //viewInstance.Initialize();

            ViewResult result = View(viewInstance);

            return result;
        }

        private string CreateMessage(string value)
        {
            if (String.IsNullOrWhiteSpace(value) == false)
            {
                return value;
            }
            else
            {
                return "(no selection)";
            }
        }

        [HttpPost]
        public ActionResult Index(ListControlsModel model)
        {
            StringBuilder builder = new StringBuilder();

            builder.AppendLine(String.Format("The last selected combobox value was '{0}'. ", model.Combobox.SelectedValue));
            builder.AppendFormat(String.Format("Checkbox value is '{0}'. ", model.IsCheckboxSelected));
            builder.AppendLine();
            builder.AppendFormat(String.Format("Listbox values are '{0}'. ", ToString(model.Listbox.SelectedValues)));
            builder.AppendLine();            

            model.Message = builder.ToString();

            model.CheckboxMessage = model.IsCheckboxSelected.ToString();
            model.ListboxMessage = CreateMessage(ToString(model.Listbox.SelectedValues));
            model.ComboboxMessage = CreateMessage(model.Combobox.SelectedValue);

            ViewResult result = View(model);

            return result;
        }

        private string ToString(List<string> selectedValues)
        {
            if (selectedValues == null || selectedValues.Count == 0)
            {
                return String.Empty;
            }
            else
            {
                bool needsComma = false;

                StringBuilder builder = new StringBuilder();

                foreach (var item in selectedValues)
                {
                    if (needsComma == true)
                    {
                        builder.Append(", ");
                    }

                    builder.Append(item);

                    needsComma = true;
                }

                return builder.ToString();
            }
        }
    }
}
